// RotaceBitu.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <stdio.h>
#include <conio.h>

// veskera hlavni funkcionalita je napsana na trech radcich teto funkce
// dostane znak (8 bitu) a vrati jiny znak, ktery je z puvodniho spocitan
// tak, ze vsechny bity jsou posunuty doleva o jednu pozici a nejvyssi bit,
// ktery jiz neni kam dat, se presune na zacatek (do nejnizsiho bitu).
unsigned char rotuj(unsigned char ch)
{
	// nejprve si zjistime, jestli je v nejvyssim bitu jednicka, to si
	// potrebujeme zapamatovat, protoze dale bude shift doleva a tento nejvyssi
	// bit se nam ztrati. Je pouzit ternarni operator, ktery zpusobi, ze pokud
	// se (ch & 128) vyhodnoti na neco nenuloveho, do promenne vrchni_bit se priradi
	// jednicka, pokud se vyhodnoti na nulu, priradi se nula.
	// 128 je binarne zapsano 10000000, tj. bit nastaven presne na te nejvyssi pozici,
	// kterou chceme kontrolovat. Tedy z uvedene operace vyleze nenulova vec prave
	// tehdy, kdyz nejvyssi bit v ch je jednicka
	char vrchni_bit = (ch & 128) ? 1 : 0;

	// ted si posuneme vsechny bity doleva o jednu pozici, a na nejnizsim se objevi
	// nula
	ch <<= 1;

	// vsechny bity jsou v poradku az na nejnizsi, kam musime dat jednicku, pokud
	// byla v nejvyssim jednicka, tj. pokud vrchni_bit obsahuje jednicku.
	// To se udela napr. prictenim jednicky k danemu cislu, a protoze kdyz nechceme
	// udelat nic, mame v promenne vrchni_bit nulu, muzeme pricitat rovnou tuto
	// promennou, jelikoz pricteni nuly s ch nic neudela.
	return ch + vrchni_bit;
}

// pomocna funkce, ktera vypisuje cislo binarne
void vypis_bity(unsigned char ch)
{
	// mame 8 bitu, opakujeme osmkrat nasledujici akci:
	for (int i = 0; i < 8; i++)
	{
		// vypiseme jednicku, pokud je nastaven nejvyssi bit, jinak nulu
		// (ch & 128) se vyhodnoti na 128 jestlize je v nejvyssim bitu jednicka,
		// abychom dostali tu jednicku, musime 128 vydelit. A deleni ma tu vyhodu,
		// ze kdyz je tam nula, (ch & 128) se vyhodnoti na nulu a 0/128 je take nula
		// a tu potrebujeme vypsat
		printf("%d", (ch & 128)/128);

		// a posuneme si ostatni bity o jednu doleva, ted mame tedy v nejvyssim
		// bitu ten, ktery byl hned za nim
		ch <<= 1;
	}

	// a toto odradkuje (vypisuje prazdny retezec, ale funkce puts() za kazdym
	// vypisem odradkovava, tedy toto zpusobi pouze odradkovani).
	puts("");
}


int main()
{
	// zvolime na vyzkouseni napr. cislo 71
	unsigned char ch = 71;
	

	puts("Cislo 71 a pak osmkrat zarotovane doleva:");
	// vypiseme cislo binarne tak jak je na zacatku
	vypis_bity(ch);

	// a 8-krat ho zarotujeme a vypiseme. Posledni vypis by se mel shodovat s prvnim.
	for (int i = 1; i <= 8; i++)
	{
		ch = rotuj(ch);
		vypis_bity(ch);
	}

	puts("Posledni cislo by melo byt stejne jako prvni.");

	getch();
	return 0;
}

